from asdl import pybase

option_t = int  # type alias for integer

class option_i(object):
  errexit = 1
  nounset = 2
  pipefail = 3
  inherit_errexit = 4
  nullglob = 5
  verbose_errexit = 6
  noexec = 7
  xtrace = 8
  verbose = 9
  noglob = 10
  noclobber = 11
  errtrace = 12
  posix = 13
  vi = 14
  emacs = 15
  interactive = 16
  hashall = 17
  lastpipe = 18
  failglob = 19
  extglob = 20
  nocasematch = 21
  dotglob = 22
  eval_unsafe_arith = 23
  ignore_flags_not_impl = 24
  ignore_shopt_not_impl = 25
  _allow_command_sub = 26
  _allow_process_sub = 27
  dynamic_scope = 28
  redefine_const = 29
  redefine_source = 30
  _running_trap = 31
  _running_hay = 32
  _no_debug_trap = 33
  _no_err_trap = 34
  strict_parse_slice = 35
  strict_argv = 36
  strict_arith = 37
  strict_array = 38
  strict_control_flow = 39
  strict_errexit = 40
  strict_nameref = 41
  strict_word_eval = 42
  strict_tilde = 43
  strict_glob = 44
  parse_at = 45
  parse_proc = 46
  parse_func = 47
  parse_brace = 48
  parse_bracket = 49
  parse_equals = 50
  parse_paren = 51
  parse_ysh_string = 52
  parse_triple_quote = 53
  simple_word_eval = 54
  dashglob = 55
  command_sub_errexit = 56
  process_sub_fail = 57
  xtrace_rich = 58
  xtrace_details = 59
  sigpipe_status_ok = 60
  env_obj = 61
  parse_at_all = 62
  parse_backslash = 63
  parse_backticks = 64
  parse_dollar = 65
  parse_ignored = 66
  parse_sh_arith = 67
  parse_dparen = 68
  parse_dbracket = 69
  parse_bare_word = 70
  no_exported = 71
  no_init_globals = 72
  simple_echo = 73
  simple_eval_builtin = 74
  simple_test_builtin = 75
  expand_aliases = 76
  progcomp = 77
  histappend = 78
  hostcomplete = 79
  cmdhist = 80
  assoc_expand_once = 81
  autocd = 82
  cdable_vars = 83
  cdspell = 84
  checkhash = 85
  checkjobs = 86
  checkwinsize = 87
  complete_fullquote = 88
  direxpand = 89
  dirspell = 90
  execfail = 91
  extdebug = 92
  extquote = 93
  force_fignore = 94
  globasciiranges = 95
  globstar = 96
  gnu_errfmt = 97
  histreedit = 98
  histverify = 99
  huponexit = 100
  interactive_comments = 101
  lithist = 102
  localvar_inherit = 103
  localvar_unset = 104
  login_shell = 105
  mailwarn = 106
  no_empty_cmd_completion = 107
  nocaseglob = 108
  progcomp_alias = 109
  promptvars = 110
  restricted_shell = 111
  shift_verbose = 112
  sourcepath = 113
  xpg_echo = 114
  ARRAY_SIZE = 115

_option_str = {
  1: 'errexit',
  2: 'nounset',
  3: 'pipefail',
  4: 'inherit_errexit',
  5: 'nullglob',
  6: 'verbose_errexit',
  7: 'noexec',
  8: 'xtrace',
  9: 'verbose',
  10: 'noglob',
  11: 'noclobber',
  12: 'errtrace',
  13: 'posix',
  14: 'vi',
  15: 'emacs',
  16: 'interactive',
  17: 'hashall',
  18: 'lastpipe',
  19: 'failglob',
  20: 'extglob',
  21: 'nocasematch',
  22: 'dotglob',
  23: 'eval_unsafe_arith',
  24: 'ignore_flags_not_impl',
  25: 'ignore_shopt_not_impl',
  26: '_allow_command_sub',
  27: '_allow_process_sub',
  28: 'dynamic_scope',
  29: 'redefine_const',
  30: 'redefine_source',
  31: '_running_trap',
  32: '_running_hay',
  33: '_no_debug_trap',
  34: '_no_err_trap',
  35: 'strict_parse_slice',
  36: 'strict_argv',
  37: 'strict_arith',
  38: 'strict_array',
  39: 'strict_control_flow',
  40: 'strict_errexit',
  41: 'strict_nameref',
  42: 'strict_word_eval',
  43: 'strict_tilde',
  44: 'strict_glob',
  45: 'parse_at',
  46: 'parse_proc',
  47: 'parse_func',
  48: 'parse_brace',
  49: 'parse_bracket',
  50: 'parse_equals',
  51: 'parse_paren',
  52: 'parse_ysh_string',
  53: 'parse_triple_quote',
  54: 'simple_word_eval',
  55: 'dashglob',
  56: 'command_sub_errexit',
  57: 'process_sub_fail',
  58: 'xtrace_rich',
  59: 'xtrace_details',
  60: 'sigpipe_status_ok',
  61: 'env_obj',
  62: 'parse_at_all',
  63: 'parse_backslash',
  64: 'parse_backticks',
  65: 'parse_dollar',
  66: 'parse_ignored',
  67: 'parse_sh_arith',
  68: 'parse_dparen',
  69: 'parse_dbracket',
  70: 'parse_bare_word',
  71: 'no_exported',
  72: 'no_init_globals',
  73: 'simple_echo',
  74: 'simple_eval_builtin',
  75: 'simple_test_builtin',
  76: 'expand_aliases',
  77: 'progcomp',
  78: 'histappend',
  79: 'hostcomplete',
  80: 'cmdhist',
  81: 'assoc_expand_once',
  82: 'autocd',
  83: 'cdable_vars',
  84: 'cdspell',
  85: 'checkhash',
  86: 'checkjobs',
  87: 'checkwinsize',
  88: 'complete_fullquote',
  89: 'direxpand',
  90: 'dirspell',
  91: 'execfail',
  92: 'extdebug',
  93: 'extquote',
  94: 'force_fignore',
  95: 'globasciiranges',
  96: 'globstar',
  97: 'gnu_errfmt',
  98: 'histreedit',
  99: 'histverify',
  100: 'huponexit',
  101: 'interactive_comments',
  102: 'lithist',
  103: 'localvar_inherit',
  104: 'localvar_unset',
  105: 'login_shell',
  106: 'mailwarn',
  107: 'no_empty_cmd_completion',
  108: 'nocaseglob',
  109: 'progcomp_alias',
  110: 'promptvars',
  111: 'restricted_shell',
  112: 'shift_verbose',
  113: 'sourcepath',
  114: 'xpg_echo',
}

def option_str(val, dot=True):
  # type: (option_t, bool) -> str
  v = _option_str[val]
  if dot:
    return "option.%s" % v
  else:
    return v

builtin_t = int  # type alias for integer

class builtin_i(object):
  colon = 1
  dot = 2
  exec_ = 3
  eval = 4
  set = 5
  shift = 6
  times = 7
  trap = 8
  unset = 9
  readonly = 10
  local = 11
  declare = 12
  typeset = 13
  export_ = 14
  extern_ = 15
  true_ = 16
  false_ = 17
  try_ = 18
  assert_ = 19
  read = 20
  echo = 21
  printf = 22
  mapfile = 23
  readarray = 24
  cd = 25
  pushd = 26
  popd = 27
  dirs = 28
  pwd = 29
  source = 30
  umask = 31
  ulimit = 32
  wait = 33
  jobs = 34
  fg = 35
  bg = 36
  shopt = 37
  complete = 38
  compgen = 39
  compopt = 40
  compadjust = 41
  compexport = 42
  getopts = 43
  builtin = 44
  command = 45
  type = 46
  hash = 47
  help = 48
  history = 49
  alias = 50
  unalias = 51
  bind = 52
  append = 53
  write = 54
  json = 55
  json8 = 56
  pp = 57
  hay = 58
  haynode = 59
  use = 60
  error = 61
  failed = 62
  fork = 63
  forkwait = 64
  redir = 65
  fopen = 66
  shvar = 67
  ctx = 68
  invoke = 69
  runproc = 70
  boolstatus = 71
  test = 72
  bracket = 73
  push_registers = 74
  source_guard = 75
  is_main = 76
  cat = 77
  ARRAY_SIZE = 78

_builtin_str = {
  1: 'colon',
  2: 'dot',
  3: 'exec_',
  4: 'eval',
  5: 'set',
  6: 'shift',
  7: 'times',
  8: 'trap',
  9: 'unset',
  10: 'readonly',
  11: 'local',
  12: 'declare',
  13: 'typeset',
  14: 'export_',
  15: 'extern_',
  16: 'true_',
  17: 'false_',
  18: 'try_',
  19: 'assert_',
  20: 'read',
  21: 'echo',
  22: 'printf',
  23: 'mapfile',
  24: 'readarray',
  25: 'cd',
  26: 'pushd',
  27: 'popd',
  28: 'dirs',
  29: 'pwd',
  30: 'source',
  31: 'umask',
  32: 'ulimit',
  33: 'wait',
  34: 'jobs',
  35: 'fg',
  36: 'bg',
  37: 'shopt',
  38: 'complete',
  39: 'compgen',
  40: 'compopt',
  41: 'compadjust',
  42: 'compexport',
  43: 'getopts',
  44: 'builtin',
  45: 'command',
  46: 'type',
  47: 'hash',
  48: 'help',
  49: 'history',
  50: 'alias',
  51: 'unalias',
  52: 'bind',
  53: 'append',
  54: 'write',
  55: 'json',
  56: 'json8',
  57: 'pp',
  58: 'hay',
  59: 'haynode',
  60: 'use',
  61: 'error',
  62: 'failed',
  63: 'fork',
  64: 'forkwait',
  65: 'redir',
  66: 'fopen',
  67: 'shvar',
  68: 'ctx',
  69: 'invoke',
  70: 'runproc',
  71: 'boolstatus',
  72: 'test',
  73: 'bracket',
  74: 'push_registers',
  75: 'source_guard',
  76: 'is_main',
  77: 'cat',
}

def builtin_str(val, dot=True):
  # type: (builtin_t, bool) -> str
  v = _builtin_str[val]
  if dot:
    return "builtin.%s" % v
  else:
    return v

